#ifdef _WIN32
#include <windows.h>
#include <direct.h>
#define MKDIR(a,b) mkdir(a)
#else
#define MKDIR(a,b) mkdir(a, b)
#endif
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include "createdirectorytree.h"



#ifdef MAIN
void main()
    {
    CreateDirectoryTree( "g:/toto\\tutu/titi\\tata/" );
    }
#endif


/*---------------------------------------------------------------------------
**
**        CREATEDIRECTORYTREE
**---------------------------------------------------------------------------
**
**  DESCRIPTION
**        --CreateDirectoryTree--
**
**	Do what you think !
**
**  ARGUMENTS
**        Argument1: char * pszDirectory
**  RETOUR/RESULTAT
**        int 0	Ok
**  DIAGNOSTIC
**  IMPLEMENTATION
**  REMARQUE
**  Rev 17/04/2001 
**--------------------------------------------------------------------------*/
int CreateDirectoryTree( char * pszDirectory )
{
    struct stat buf;
    
    if( stat( pszDirectory, &buf ) != 0 && errno == ENOENT )
    {
	int nRet = 1;
	char * pszTemp; int cb;
	pszTemp = strdup( pszDirectory );
	if( pszTemp == NULL )
	    return 0;
	cb = strlen(pszTemp);
	
	if( pszTemp[cb-1] == '/' || pszTemp[cb-1] == '\\' )
	{
	    pszTemp[cb-1] = 0;
	    cb --;
	}
	
	while( cb > 0 && pszTemp[cb-1] != '/' && pszTemp[cb-1] != '\\' && pszTemp[cb-1] != ':' )
	{
	    pszTemp[cb-1] = 0;
	    cb --;
	}
	
	if( CreateDirectoryTree( pszTemp ) )
	{
	    if( MKDIR( pszDirectory, 0644 ) != 0 && errno != EEXIST )
		nRet = -1;
	}
	free( pszTemp );
	return nRet;
    }
    if( buf.st_mode  & S_IFDIR )
	return 0;
    return -1;
}
